diff --git a/arch/arm/dts/Makefile b/arch/arm/dts/Makefile
index 33e483f4fb..1f678c4ed1 100644
--- a/arch/arm/dts/Makefile
+++ b/arch/arm/dts/Makefile
@@ -199,7 +199,6 @@ dtb-$(CONFIG_ARCH_TEGRA) += tegra20-harmony.dtb \
 	tegra124-venice2.dtb \
 	tegra186-p2771-0000-000.dtb \
 	tegra186-p2771-0000-500.dtb \
-	tegra210-e2220-1170.dtb \
 	tegra210-p2371-0000.dtb \
 	tegra210-p2371-2180.dtb \
 	tegra210-p2571.dtb \
diff --git a/arch/arm/dts/tegra210-e2220-1170.dts b/arch/arm/dts/tegra210-e2220-1170.dts
deleted file mode 100644
index e6b06862d8..0000000000
--- a/arch/arm/dts/tegra210-e2220-1170.dts
+++ /dev/null
@@ -1,63 +0,0 @@
-/dts-v1/;
-
-#include "tegra210.dtsi"
-
-/ {
-	model = "NVIDIA E2220-1170";
-	compatible = "nvidia,e2220-1170", "nvidia,tegra210";
-
-	chosen {
-		stdout-path = &uarta;
-	};
-
-	aliases {
-		i2c0 = "/i2c@7000d000";
-		mmc0 = "/sdhci@700b0600";
-		mmc1 = "/sdhci@700b0000";
-		usb0 = "/usb@7d000000";
-	};
-
-	memory {
-		reg = <0x0 0x80000000 0x0 0xc0000000>;
-	};
-
-	sdhci@700b0000 {
-		status = "okay";
-		cd-gpios = <&gpio TEGRA_GPIO(Z, 1) GPIO_ACTIVE_LOW>;
-		power-gpios = <&gpio TEGRA_GPIO(Z, 4) GPIO_ACTIVE_HIGH>;
-		bus-width = <4>;
-	};
-
-	sdhci@700b0600 {
-		status = "okay";
-		bus-width = <8>;
-		non-removable;
-	};
-
-	i2c@7000d000 {
-		status = "okay";
-		clock-frequency = <400000>;
-	};
-
-	usb@7d000000 {
-		status = "okay";
-		dr_mode = "peripheral";
-	};
-
-	clocks {
-		compatible = "simple-bus";
-		#address-cells = <1>;
-		#size-cells = <0>;
-
-		clk32k_in: clock@0 {
-			compatible = "fixed-clock";
-			reg = <0>;
-			#clock-cells = <0>;
-			clock-frequency = <32768>;
-		};
-	};
-};
-
-&uarta {
-	status = "okay";
-};
diff --git a/arch/arm/mach-tegra/tegra210/Kconfig b/arch/arm/mach-tegra/tegra210/Kconfig
index 97ed8e05f4..17f18cbf30 100644
--- a/arch/arm/mach-tegra/tegra210/Kconfig
+++ b/arch/arm/mach-tegra/tegra210/Kconfig
@@ -3,14 +3,6 @@ if TEGRA210
 choice
 	prompt "Tegra210 board select"
 
-config TARGET_E2220_1170
-	bool "NVIDIA Tegra210 E2220-1170 board"
-	select BOARD_LATE_INIT
-	help
-	  E2220-1170 is a Tegra210 bringup board with onboard SoC, DRAM,
-	  eMMC, SD card slot, HDMI, USB micro-B port, and sockets for various
-	  expansion modules.
-
 config TARGET_P2371_0000
 	bool "NVIDIA Tegra210 P2371-0000 board"
 	select BOARD_LATE_INIT
@@ -46,7 +38,6 @@ endchoice
 config SYS_SOC
 	default "tegra210"
 
-source "board/nvidia/e2220-1170/Kconfig"
 source "board/nvidia/p2371-0000/Kconfig"
 source "board/nvidia/p2371-2180/Kconfig"
 source "board/nvidia/p2571/Kconfig"
diff --git a/board/nvidia/e2220-1170/Kconfig b/board/nvidia/e2220-1170/Kconfig
deleted file mode 100644
index 0a30f49362..0000000000
--- a/board/nvidia/e2220-1170/Kconfig
+++ /dev/null
@@ -1,12 +0,0 @@
-if TARGET_E2220_1170
-
-config SYS_BOARD
-	default "e2220-1170"
-
-config SYS_VENDOR
-	default "nvidia"
-
-config SYS_CONFIG_NAME
-	default "e2220-1170"
-
-endif
diff --git a/board/nvidia/e2220-1170/MAINTAINERS b/board/nvidia/e2220-1170/MAINTAINERS
deleted file mode 100644
index 0abb378840..0000000000
--- a/board/nvidia/e2220-1170/MAINTAINERS
+++ /dev/null
@@ -1,6 +0,0 @@
-E2220-1170 BOARD
-M:	Tom Warren <twarren@nvidia.com>
-S:	Maintained
-F:	board/nvidia/e2220-1170/
-F:	include/configs/e2220-1170.h
-F:	configs/e2220-1170_defconfig
diff --git a/board/nvidia/e2220-1170/Makefile b/board/nvidia/e2220-1170/Makefile
deleted file mode 100644
index c956b1972d..0000000000
--- a/board/nvidia/e2220-1170/Makefile
+++ /dev/null
@@ -1,8 +0,0 @@
-#
-# (C) Copyright 2013-2015
-# NVIDIA Corporation <www.nvidia.com>
-#
-# SPDX-License-Identifier:     GPL-2.0+
-#
-
-obj-y	+= e2220-1170.o
diff --git a/board/nvidia/e2220-1170/e2220-1170.c b/board/nvidia/e2220-1170/e2220-1170.c
deleted file mode 100644
index b819b049f4..0000000000
--- a/board/nvidia/e2220-1170/e2220-1170.c
+++ /dev/null
@@ -1,32 +0,0 @@
-// SPDX-License-Identifier: GPL-2.0+
-/*
- * (C) Copyright 2013-2019
- * NVIDIA Corporation <www.nvidia.com>
- */
-
-#include <common.h>
-#include <i2c.h>
-#include <log.h>
-#include <asm/arch/gpio.h>
-#include <asm/arch/pinmux.h>
-#include "../p2571/max77620_init.h"
-
-void pin_mux_mmc(void)
-{
-	struct udevice *dev;
-	uchar val;
-	int ret;
-
-	/* Turn on MAX77620 LDO2 to 3.3V for SD card power */
-	debug("%s: Set LDO2 for VDDIO_SDMMC_AP power to 3.3V\n", __func__);
-	ret = i2c_get_chip_for_busnum(0, MAX77620_I2C_ADDR_7BIT, 1, &dev);
-	if (ret) {
-		printf("%s: Cannot find MAX77620 I2C chip\n", __func__);
-		return;
-	}
-	/* 0xF2 for 3.3v, enabled: bit7:6 = 11 = enable, bit5:0 = voltage */
-	val = 0xF2;
-	ret = dm_i2c_write(dev, MAX77620_CNFG1_L2_REG, &val, 1);
-	if (ret)
-		printf("i2c_write 0 0x3c 0x27 failed: %d\n", ret);
-}
diff --git a/configs/e2220-1170_defconfig b/configs/e2220-1170_defconfig
deleted file mode 100644
index efe3f8b574..0000000000
--- a/configs/e2220-1170_defconfig
+++ /dev/null
@@ -1,48 +0,0 @@
-CONFIG_ARM=y
-CONFIG_ARCH_TEGRA=y
-CONFIG_SYS_TEXT_BASE=0x80080000
-CONFIG_NR_DRAM_BANKS=2
-CONFIG_ENV_SIZE=0x2000
-CONFIG_ENV_OFFSET=0xFFFFE000
-CONFIG_TEGRA210=y
-CONFIG_DEFAULT_DEVICE_TREE="tegra210-e2220-1170"
-CONFIG_OF_SYSTEM_SETUP=y
-CONFIG_CONSOLE_MUX=y
-CONFIG_SYS_STDIO_DEREGISTER=y
-CONFIG_SYS_PROMPT="Tegra210 (E2220-1170) # "
-# CONFIG_CMD_IMI is not set
-CONFIG_CMD_DFU=y
-CONFIG_CMD_GPIO=y
-CONFIG_CMD_I2C=y
-CONFIG_CMD_MMC=y
-CONFIG_CMD_SPI=y
-CONFIG_CMD_USB=y
-CONFIG_CMD_USB_MASS_STORAGE=y
-# CONFIG_CMD_SETEXPR is not set
-CONFIG_BOOTP_PREFER_SERVERIP=y
-# CONFIG_CMD_NFS is not set
-CONFIG_CMD_EXT4_WRITE=y
-CONFIG_ENV_OVERWRITE=y
-CONFIG_SYS_RELOC_GD_ENV_ADDR=y
-CONFIG_SYS_MMC_ENV_PART=2
-CONFIG_DFU_MMC=y
-CONFIG_DFU_RAM=y
-CONFIG_DFU_SF=y
-CONFIG_SYS_I2C_TEGRA=y
-CONFIG_SF_DEFAULT_MODE=0
-CONFIG_SF_DEFAULT_SPEED=24000000
-CONFIG_SPI_FLASH_WINBOND=y
-CONFIG_SYS_NS16550=y
-CONFIG_TEGRA114_SPI=y
-CONFIG_USB=y
-CONFIG_DM_USB=y
-CONFIG_USB_EHCI_HCD=y
-CONFIG_USB_EHCI_TEGRA=y
-CONFIG_USB_GADGET=y
-CONFIG_USB_GADGET_MANUFACTURER="NVIDIA"
-CONFIG_USB_GADGET_VENDOR_NUM=0x0955
-CONFIG_USB_GADGET_PRODUCT_NUM=0x701a
-CONFIG_CI_UDC=y
-CONFIG_USB_GADGET_DOWNLOAD=y
-CONFIG_USB_HOST_ETHER=y
-CONFIG_USB_ETHER_ASIX=y
diff --git a/include/configs/e2220-1170.h b/include/configs/e2220-1170.h
deleted file mode 100644
index 5ed62678ce..0000000000
--- a/include/configs/e2220-1170.h
+++ /dev/null
@@ -1,28 +0,0 @@
-/* SPDX-License-Identifier: GPL-2.0+ */
-/*
- * (C) Copyright 2013-2015
- * NVIDIA Corporation <www.nvidia.com>
- */
-
-#ifndef _E2220_1170_H
-#define _E2220_1170_H
-
-#include <linux/sizes.h>
-
-#include "tegra210-common.h"
-
-/* High-level configuration options */
-#define CONFIG_TEGRA_BOARD_STRING	"NVIDIA E2220-1170"
-
-/* Board-specific serial config */
-#define CONFIG_TEGRA_ENABLE_UARTA
-
-/* Environment in eMMC, at the end of 2nd "boot sector" */
-
-/* SPI */
-#define CONFIG_SPI_FLASH_SIZE		(4 << 20)
-
-#include "tegra-common-usb-gadget.h"
-#include "tegra-common-post.h"
-
-#endif /* _E2220_1170_H */